#include"Solver.h"



void ConstructionHeuristics::Solve(Coloring &current)
{
  p_runner->initialization_procedure(current);
  p_ctrl->setCurrentCost(current.fitness,current.CurrColors(),0);
}




void Metaheuristic_Descend::Solve(Coloring &initial)
 {
  
  Coloring current(initial);
  total_iterations = 0;
  p_runner->initialization_procedure(current);
  p_ctrl->setCurrentCost(current.fitness,current.CurrColors(),0);  
  while (!MaxIterationExpired() && p_ctrl->timeLeft())
    {
      if (current.feasible)
	{
	  initial = current;
	  p_runner->decreasing_procedure(current);
	  p_ctrl->setCurrentCost(current.fitness,current.CurrColors(),0);
	}
      p_runner->SetMaxIteration(p_ctrl->max_iter-total_iterations);
      p_runner->Run_procedure(current);
      total_iterations = total_iterations + p_runner->NumberOfIterations();
      p_ctrl->setPartialIter(total_iterations);
      //      if (current.fitness!=0)
      //	  break;
      //break;// <--- remove
    }
  p_ctrl->setPartialIter(total_iterations);
}
