/* This file has been generated with opag 0.8.0.  */
#include <iostream>
#include <sstream>
#include <stdexcept>
#include <string>
#include "Control.h"

using namespace std;
using std::ostringstream; using std::string;



#ifndef STR_ERR_UNKNOWN_LONG_OPT
# define STR_ERR_UNKNOWN_LONG_OPT \
  ::std::string ("unrecognized option `--").append (option).append (1, '\'')
#endif

#ifndef STR_ERR_LONG_OPT_AMBIGUOUS
# define STR_ERR_LONG_OPT_AMBIGUOUS \
  ::std::string ("option `--").append (option).append ("' is ambiguous")
#endif

#ifndef STR_ERR_MISSING_ARG_LONG
# define STR_ERR_MISSING_ARG_LONG \
  ::std::string ("option `--").append (option).append ("' requires an argument")
#endif

#ifndef STR_ERR_UNEXPEC_ARG_LONG
# define STR_ERR_UNEXPEC_ARG_LONG \
  ::std::string ("option `--").append (option).append ("' doesn't allow an argument")
#endif

#ifndef STR_ERR_UNKNOWN_SHORT_OPT
# define STR_ERR_UNKNOWN_SHORT_OPT \
  ::std::string ("unrecognized option `-").append (1, *option).append (1, '\'')
#endif

#ifndef STR_ERR_MISSING_ARG_SHORT
# define STR_ERR_MISSING_ARG_SHORT \
  ::std::string ("option `-").append (1, *option).append ("' requires an argument")
#endif

#define STR_HELP_FILE "\
  -i, --file f      inputfile (DIMACS format necessary)\n"

#define STR_HELP_OUT "\
  -o, --out f       outputfile \n"

#define STR_HELP_NUM "\
  -n, --num         number of tests\n"

#define STR_HELP_TIME "\
  -t, --time        maximum time\n"

#define STR_HELP_MAX "\
  -m, --max         number of iterations for each trial (optarg)\n"

#define STR_HELP_SEED "\
  -s, --seed        seed\n"

#define STR_HELP_INIT "\
      --init        way of initializing a solution: \n"

#define STR_HELP_DECR "\
      --decr        way to decrease colors \n"

#define STR_HELP_NEIGH "\
      --neigh       the neighborhood\n"

#define STR_HELP_SOLVER "\
      --solver      Solver: \n"

#define STR_HELP_TEST "\
      --test        run test version (1) or not (0) (optarg)\n"

#define STR_HELP_STAT "\
      --stat        prints instance statistics and reduction (optarg)\n"

#define STR_HELP_INITK "\
  -k, --initK       initial coloring\n"

#define STR_HELP_FINALK "\
  -K, --finalK      final coloring\n"

#define STR_HELP_HELP "\
  -h, --help        prints help information\n"

#define STR_HELP_MOREHELP "\
      --morehelp    prints some more help information\n"

#define STR_HELP "\
  -i, --file f      inputfile (DIMACS format necessary)\n\
  -o, --out f       outputfile \n\
  -n, --num         number of tests\n\
  -t, --time        maximum time\n\
  -m, --max         number of iterations for each trial (optarg)\n\
  -s, --seed        seed\n\
      --init        way of initializing a solution: \n\
      --decr        way to decrease colors \n\
      --neigh       the neighborhood\n\
      --solver      Solver: \n\
      --test        run test version (1) or not (0) (optarg)\n\
      --stat        prints instance statistics and reduction (optarg)\n\
  -k, --initK       initial coloring\n\
  -K, --finalK      final coloring\n\
  -h, --help        prints help information\n\
      --morehelp    prints some more help information\n"

struct options {

/* Set to 1 if option --file (-i) has been specified.  */
unsigned int opt_file : 1;

/* Set to 1 if option --out (-o) has been specified.  */
unsigned int opt_out : 1;

/* Set to 1 if option --num (-n) has been specified.  */
unsigned int opt_num : 1;

/* Set to 1 if option --time (-t) has been specified.  */
unsigned int opt_time : 1;

/* Set to 1 if option --max (-m) has been specified.  */
unsigned int opt_max : 1;

/* Set to 1 if option --seed (-s) has been specified.  */
unsigned int opt_seed : 1;

/* Set to 1 if option --init has been specified.  */
unsigned int opt_init : 1;

/* Set to 1 if option --decr has been specified.  */
unsigned int opt_decr : 1;

/* Set to 1 if option --neigh has been specified.  */
unsigned int opt_neigh : 1;

/* Set to 1 if option --solver has been specified.  */
unsigned int opt_solver : 1;

/* Set to 1 if option --test has been specified.  */
unsigned int opt_test : 1;

/* Set to 1 if option --stat has been specified.  */
unsigned int opt_stat : 1;

/* Set to 1 if option --initK (-k) has been specified.  */
unsigned int opt_initk : 1;

/* Set to 1 if option --finalK (-K) has been specified.  */
unsigned int opt_finalk : 1;

/* Set to 1 if option --help (-h) has been specified.  */
unsigned int opt_help : 1;

/* Set to 1 if option --morehelp has been specified.  */
unsigned int opt_morehelp : 1;

/* Argument to option --file (-i).  */
const char *arg_file;

/* Argument to option --out (-o).  */
const char *arg_out;

/* Argument to option --num (-n).  */
const char *arg_num;

/* Argument to option --time (-t).  */
const char *arg_time;

/* Argument to option --max (-m), or a null pointer if no argument.  */
const char *arg_max;

/* Argument to option --seed (-s).  */
const char *arg_seed;

/* Argument to option --init.  */
const char *arg_init;

/* Argument to option --decr.  */
const char *arg_decr;

/* Argument to option --neigh.  */
const char *arg_neigh;

/* Argument to option --solver.  */
const char *arg_solver;

/* Argument to option --test, or a null pointer if no argument.  */
const char *arg_test;

/* Argument to option --stat, or a null pointer if no argument.  */
const char *arg_stat;

/* Argument to option --initK (-k).  */
const char *arg_initk;

/* Argument to option --finalK (-K).  */
const char *arg_finalk;

};

/* Parse command line options.  Return index of first non-option argument.
   Throw a ::std::runtime_error exception if an error is encountered.  */
int parse_options (options *const options, const int argc, char **const argv)
{
  static const char *const optstr__file = "file";
  static const char *const optstr__out = "out";
  static const char *const optstr__num = "num";
  static const char *const optstr__time = "time";
  static const char *const optstr__seed = "seed";
  static const char *const optstr__init = "init";
  static const char *const optstr__decr = "decr";
  static const char *const optstr__neigh = "neigh";
  static const char *const optstr__solver = "solver";
  static const char *const optstr__initk = "initK";
  static const char *const optstr__finalk = "finalK";
  static const char *const optstr__help = "help";
  static const char *const optstr__morehelp = "morehelp";
  int i = 0;
  options->opt_file = 0;
  options->opt_out = 0;
  options->opt_num = 0;
  options->opt_time = 0;
  options->opt_max = 0;
  options->opt_seed = 0;
  options->opt_init = 0;
  options->opt_decr = 0;
  options->opt_neigh = 0;
  options->opt_solver = 0;
  options->opt_test = 0;
  options->opt_stat = 0;
  options->opt_initk = 0;
  options->opt_finalk = 0;
  options->opt_help = 0;
  options->opt_morehelp = 0;
  options->arg_file = 0;
  options->arg_out = 0;
  options->arg_num = 0;
  options->arg_time = 0;
  options->arg_max = 0;
  options->arg_seed = 0;
  options->arg_init = 0;
  options->arg_decr = 0;
  options->arg_neigh = 0;
  options->arg_solver = 0;
  options->arg_test = 0;
  options->arg_stat = 0;
  options->arg_initk = 0;
  options->arg_finalk = 0;
  while (++i < argc)
  {
    const char *option = argv [i];
    if (*option != '-')
      return i;
    else if (*++option == '\0')
      return i;
    else if (*option == '-')
    {
      const char *argument;
      ::std::size_t option_len;
      ++option;
      if ((argument = ::std::strchr (option, '=')) == option)
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
      else if (argument == 0)
        option_len = ::std::strlen (option);
      else
        option_len = argument++ - option;
      switch (*option)
      {
       case '\0':
        return i + 1;
       case 'd':
        if (::std::strncmp (option + 1, optstr__decr + 1, option_len - 1) == 0)
        {
          if (argument != 0)
            options->arg_decr = argument;
          else if (++i < argc)
            options->arg_decr = argv [i];
          else
          {
            option = optstr__decr;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_decr = 1;
          break;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 'f':
        if (::std::strncmp (option + 1, optstr__file + 1, option_len - 1) == 0)
        {
          if (option_len <= 2)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_file = argument;
          else if (++i < argc)
            options->arg_file = argv [i];
          else
          {
            option = optstr__file;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_file = 1;
          break;
        }
        if (::std::strncmp (option + 1, optstr__finalk + 1, option_len - 1) == 0)
        {
          if (option_len <= 2)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_finalk = argument;
          else if (++i < argc)
            options->arg_finalk = argv [i];
          else
          {
            option = optstr__finalk;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_finalk = 1;
          break;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 'h':
        if (::std::strncmp (option + 1, optstr__help + 1, option_len - 1) == 0)
        {
          if (argument != 0)
          {
            option = optstr__help;
            throw ::std::runtime_error (STR_ERR_UNEXPEC_ARG_LONG);
          }
          options->opt_help = 1;
          return i + 1;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 'i':
        if (::std::strncmp (option + 1, optstr__init + 1, option_len - 1) == 0)
        {
          if (option_len < 4)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_init = argument;
          else if (++i < argc)
            options->arg_init = argv [i];
          else
          {
            option = optstr__init;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_init = 1;
          break;
        }
        if (::std::strncmp (option + 1, optstr__initk + 1, option_len - 1) == 0)
        {
          if (option_len <= 4)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_initk = argument;
          else if (++i < argc)
            options->arg_initk = argv [i];
          else
          {
            option = optstr__initk;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_initk = 1;
          break;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 'm':
        if (::std::strncmp (option + 1, "ax", option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          options->arg_max = argument;
          options->opt_max = 1;
          break;
        }
        if (::std::strncmp (option + 1, optstr__morehelp + 1, option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
          {
            option = optstr__morehelp;
            throw ::std::runtime_error (STR_ERR_UNEXPEC_ARG_LONG);
          }
          options->opt_morehelp = 1;
          return i + 1;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 'n':
        if (::std::strncmp (option + 1, optstr__neigh + 1, option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_neigh = argument;
          else if (++i < argc)
            options->arg_neigh = argv [i];
          else
          {
            option = optstr__neigh;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_neigh = 1;
          break;
        }
        if (::std::strncmp (option + 1, optstr__num + 1, option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_num = argument;
          else if (++i < argc)
            options->arg_num = argv [i];
          else
          {
            option = optstr__num;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_num = 1;
          break;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 'o':
        if (::std::strncmp (option + 1, optstr__out + 1, option_len - 1) == 0)
        {
          if (argument != 0)
            options->arg_out = argument;
          else if (++i < argc)
            options->arg_out = argv [i];
          else
          {
            option = optstr__out;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_out = 1;
          break;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 's':
        if (::std::strncmp (option + 1, optstr__seed + 1, option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_seed = argument;
          else if (++i < argc)
            options->arg_seed = argv [i];
          else
          {
            option = optstr__seed;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_seed = 1;
          break;
        }
        if (::std::strncmp (option + 1, optstr__solver + 1, option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_solver = argument;
          else if (++i < argc)
            options->arg_solver = argv [i];
          else
          {
            option = optstr__solver;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_solver = 1;
          break;
        }
        if (::std::strncmp (option + 1, "tat", option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          options->arg_stat = argument;
          options->opt_stat = 1;
          break;
        }
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
       case 't':
        if (::std::strncmp (option + 1, "est", option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          options->arg_test = argument;
          options->opt_test = 1;
          break;
        }
        if (::std::strncmp (option + 1, optstr__time + 1, option_len - 1) == 0)
        {
          if (option_len <= 1)
            throw ::std::runtime_error (STR_ERR_LONG_OPT_AMBIGUOUS);
          if (argument != 0)
            options->arg_time = argument;
          else if (++i < argc)
            options->arg_time = argv [i];
          else
          {
            option = optstr__time;
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_LONG);
          }
          options->opt_time = 1;
          break;
        }
       default:
        throw ::std::runtime_error (STR_ERR_UNKNOWN_LONG_OPT);
      }
    }
    else
      do
      {
        switch (*option)
        {
         case 'K':
          if (option [1] != '\0')
            options->arg_finalk = option + 1;
          else if (++i < argc)
            options->arg_finalk = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_finalk = 1;
          break;
         case 'h':
          options->opt_help = 1;
          return i + 1;
         case 'i':
          if (option [1] != '\0')
            options->arg_file = option + 1;
          else if (++i < argc)
            options->arg_file = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_file = 1;
          break;
         case 'k':
          if (option [1] != '\0')
            options->arg_initk = option + 1;
          else if (++i < argc)
            options->arg_initk = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_initk = 1;
          break;
         case 'm':
          if (option [1] != '\0')
          {
            options->arg_max = option + 1;
            option = "\0";
          }
          else
            options->arg_max = 0;
          options->opt_max = 1;
          break;
         case 'n':
          if (option [1] != '\0')
            options->arg_num = option + 1;
          else if (++i < argc)
            options->arg_num = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_num = 1;
          break;
         case 'o':
          if (option [1] != '\0')
            options->arg_out = option + 1;
          else if (++i < argc)
            options->arg_out = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_out = 1;
          break;
         case 's':
          if (option [1] != '\0')
            options->arg_seed = option + 1;
          else if (++i < argc)
            options->arg_seed = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_seed = 1;
          break;
         case 't':
          if (option [1] != '\0')
            options->arg_time = option + 1;
          else if (++i < argc)
            options->arg_time = argv [i];
          else
            throw ::std::runtime_error (STR_ERR_MISSING_ARG_SHORT);
          option = "\0";
          options->opt_time = 1;
          break;
         default:
          throw ::std::runtime_error (STR_ERR_UNKNOWN_SHORT_OPT);
        }
      } while (*++option != '\0');
  }
  return i;
}

void Control::ComParser(int argc, char** argv ) 
  {
    struct options OPT;
    
    const char *progname;

  progname = argv [0] != 0 && *(argv [0]) != '\0'
    ? argv [0]
    : "gcp";

  try
    {
      int i = parse_options (&OPT, argc, argv);

      if (OPT.opt_help)
	{
	  //Usage();
	   std::cout << "Usage: " << progname
                             << " [OPTION]... [ARGUMENT]...\n\n"
                             << "Options:\n" STR_HELP;
	  exit(1);
	}
	  
       if(OPT.opt_morehelp)
	{	
	  Usage();
	  exit(1);
	}

      if(i <= 1)
	{
	  //Usage();
	   std::cout << "Usage: " << progname
                             << " [OPTION]... [ARGUMENT]...\n\n"
                             << "Options:\n" STR_HELP;
	   exit(1);
	}

      if (OPT.opt_file)
	{
	  is = OPT.arg_file;
	}
      else
	{
	  cerr<<"Instance file missing!\n"<<endl;
	  exit(1);
	}

      if(OPT.opt_out)
	{
	  os = new ofstream(OPT.arg_out);
	  string file_solution(OPT.arg_out);
	  file_solution.append(".sol");
	  oss = new ofstream(file_solution.c_str());
	} else {
	  cerr << "Warning: No output file given, writing to stdout" << endl;
	  os = &cout;
	  oss = &cout;
      } 
      
      if(OPT.opt_num)
	{
	  maxTry = atoi(OPT.arg_num);
	} else {
	  cerr << "Warning: Number of tries is set to default (1)" << endl;
	}

      if(OPT.opt_time)
	{
	  timeLimit = atof(OPT.arg_time);
	} else {
	  cerr << "Warning: Time limit is set to default DBL_MAX" << endl;
	}

      if(OPT.opt_max)
	{
	  if (OPT.arg_max != 0)
	    max_iter = atoi(OPT.arg_max);
	  else
	    {
	      max_iter = 0;
	      cerr << "Warning: Max iter is set to 10000 |V|"<<endl;
	    }
	} else {
	  cerr << "Warning: Max iter is set to very large number (LONG_MAX)"<<endl;
	}

       if(OPT.opt_seed)
	{
	  seed = atoi(OPT.arg_seed);
	  rg->set_seed( seed );
	} else {
	  cerr << "Warning: " << seed << " used as default random seed" << endl;
	}
	
      if(OPT.opt_init) {
	init = atoi(OPT.arg_init);
      } else {
	cerr << "Warning: init not set" << endl;
      }


      if(OPT.opt_decr)
	{
	  decr = atoi(OPT.arg_decr);
	} else {
	  cerr << "Warning: decr not set" << endl;
	}

      if(OPT.opt_neigh)
	{
	  Neighborhood = atoi(OPT.arg_neigh);
	} else {
	  cerr << "Warning: neigh not set" << endl;
	}

      if(OPT.opt_solver)
	{
	  solver = atoi(OPT.arg_solver);
	} else {
	  cerr << "Warning: solver not set" << endl;
	}

      if (OPT.opt_test)
	{
	  test_version = 1;
	  cout<<"Running Test Version"<<endl;
	} 

      if(OPT.opt_stat)
	{
	  print_statistics = true;
	}

      if (OPT.opt_initk)
	{  
	  k = atoi(OPT.arg_initk);
	} else {
	  cerr << "Warning: No initial color set" << endl;
	}

      if (OPT.opt_finalk)
	{  
	  finalK = atoi(OPT.arg_finalk);
	} else {
	  cerr << "Warning: No initial color set" << endl;
	}
	
  }
  catch (std::runtime_error e)
    {
      std::cerr << progname << ": " << e.what () << "\n"
	"Try `" << progname
		<< " --help' for more information.\n";
      exit(1);
    }
  }
